package com.zt.plat.module.base.service.tmpltp;

import java.util.*;


import com.zt.plat.module.base.controller.admin.templtp.vo.*;
import com.zt.plat.module.base.dal.dataobject.tmpltp.TmplTpDO;
import com.baomidou.mybatisplus.extension.service.IService;
import jakarta.validation.*;

import com.zt.plat.framework.common.pojo.PageResult;

/**
 * 模板分类 Service 接口
 *
 * @author 后台管理
 */
public interface TmplTpService extends IService<TmplTpDO> {

    /**
     * 创建模板分类
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    TmplTpRespVO createTmplTp(@Valid TmplTpSaveReqVO createReqVO);

    /**
     * 更新模板分类
     *
     * @param updateReqVO 更新信息
     */
    void updateTmplTp(@Valid TmplTpSaveReqVO updateReqVO);

    /**
     * 删除模板分类
     *
     * @param ids 编号
     */
    void deleteTmplTp(List<Long> ids);

    /**
     * 批量删除模板分类
     *
     * @param ids 编号
     */
    void deleteTmplTpListByIds(List<Long> ids);

    /**
     * 获得模板分类
     *
     * @param id 编号
     * @return 模板分类
     */
    TmplTpDO getTmplTp(Long id);

    /**
     * 获得模板分类分页
     *
     * @param pageReqVO 分页查询
     * @return 模板分类分页
     */
    PageResult<TmplTpDO> getTmplTpPage(TmplTpPageReqVO pageReqVO);

    /**
     * 获得字段回显
     *
     * @param id 编号
     * @return 模板分类
     */
    List<TmplFldRespVO> getField(Long id);

    /**
     * 获得条款回显
     *
     * @param id 编号
     * @return 模板分类
     */
    List<TmplItmRespVO> getClause(Long id);

    /**
     * 树结构
     *
     * @return 模板分类
     */
    List<TmplTpTreeVO> buildTree(String num, String name);

    /**
     * 更新模板分类状态
     *
     * @param id     编号
     * @param status 状态
     */
    void updateStatus(Long id, String status);

    /**
     * 字段编辑
     *
     * @param reqVO 状态
     */
    void fieldEdit(TmplTpEditOrDeleteReqVO reqVO);

    /**
     * 条款编辑
     *
     * @param reqVO 状态
     */
    void ltmEdit(TmplTpEditOrDeleteReqVO reqVO);
}
